#version 430 core

uniform float zFar;
uniform float zNear;
uniform float theta;
uniform sampler2D positionMap; // screen positins of max depth
uniform sampler2D depthMap;
uniform vec2 imgSize;

out vec4 outColor;

void main(void)
{
	vec2 p = gl_FragCoord.xy / imgSize;
	float z = texture(depthMap, p).r;
	vec4 textureSample = texture(positionMap, p);

	vec2 q = textureSample.xy / imgSize;
	vec2 qp = q - p;

	float scale = (zNear + zFar) / (zNear - zFar);
	float m = -(scale + z) / tan(theta);
	float dist = clamp(m * distance(q,p), 0.0, 1.0);
	
	// float alpha = clamp( dot(normalize(qp), vec2(0.0f,1.0f)), 0.0f, 1.0f);
	// float dist = ((1.0f-alpha)*textureSample.z + alpha*textureSample.w) * distance(q,p);
	
	float newDepth = z - dist;

	vec4 best = vec4(textureSample.xyz, newDepth);

	outColor = best;
	gl_FragDepth = newDepth;
	
}